## telegram-qt-0.1.0-4.src.tar.gz

=== CMakeLists.txt ===
project(TelegramQt)

cmake_minimum_required(VERSION 2.8)

set(TELEGRAM_QT_VERSION_MAJOR 0)
set(TELEGRAM_QT_VERSION_MINOR 1)
set(TELEGRAM_QT_VERSION_PATCH 0)

set(TELEGRAM_QT_VERSION "${TELEGRAM_QT_VERSION_MAJOR}.${TELEGRAM_QT_VERSION_MINOR}.${TELEGRAM_QT_VERSION_PATCH}")
set(TELEGRAM_QT_ABI "${TELEGRAM_QT_VERSION_MAJOR}.${TELEGRAM_QT_VERSION_MINOR}")

# Add an option for building tests
option(ENABLE_TESTS "Enable compilation of automated tests" FALSE)
# Add an option for building tests
option(ENABLE_TESTAPP "Enable compilation of testing application" FALSE)
# Add an option for building tests
option(STATIC_BUILD "Compile static library instead of shared" FALSE)
# Add an option for dev build
option(DEVELOPER_BUILD "Enable extra debug codepaths, like asserts and extra output" FALSE)

if (USE_QT4)
    set(QT_VERSION_MAJOR "4")

    if(ENABLE_TESTAPP)
        find_package(Qt4 4.8.0 REQUIRED QtCore QtNetwork QtGui)
    else()
        find_package(Qt4 4.8.0 REQUIRED QtCore QtNetwork)
    endif()
else()
    set(QT_VERSION_MAJOR "5")

    if(ENABLE_TESTAPP)
        find_package(Qt5 REQUIRED COMPONENTS Core Network Gui Widgets)
    else()
        find_package(Qt5 REQUIRED COMPONENTS Core Network)
    endif()
endif()

find_package(OpenSSL REQUIRED)
find_package(ZLIB REQUIRED)

include(GNUInstallDirs)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

# Add the source subdirectories
add_subdirectory(telegram-qt)

#if(ENABLE_TESTS)
#    add_subdirectory(tests)
#endif()

if(ENABLE_TESTAPP)
    add_subdirectory(testApp)
endif()

=== telegram-qt/CMakeLists.txt ===

set(telegram_qt_SOURCES
    TelegramNamespace.cpp
    CAppInformation.cpp
    CTelegramCore.cpp
    CTelegramDispatcher.cpp
    CTelegramConnection.cpp
    CTelegramStream.cpp
    CTcpTransport.cpp
    CRawStream.cpp
    Utils.cpp
    TelegramUtils.cpp
    TLValues.cpp
)

set(telegram_qt_META_HEADERS
    TelegramNamespace.hpp
    CTelegramCore.hpp
    CTelegramDispatcher.hpp
    CTelegramConnection.hpp
    CTelegramTransport.hpp
    CTcpTransport.hpp
    TLValues.hpp
)

set(telegram_qt_HEADERS
    telegramqt_export.h
    TelegramNamespace.hpp
    TelegramNamespace_p.hpp
    CAppInformation.hpp
    CTelegramCore.hpp
    CTelegramDispatcher.hpp
    CTelegramConnection.hpp
    CTelegramStream.hpp
    CTelegramTransport.hpp
    CTcpTransport.hpp
    CRawStream.hpp
    Utils.hpp
    TelegramUtils.hpp
    TLValues.hpp
    TLTypes.hpp
    crypto-rsa.hpp
    crypto-aes.hpp
)

set(telegram_qt_public_HEADERS
    telegramqt_export.h
    CAppInformation.hpp
    TelegramNamespace.hpp
    CTelegramCore.hpp
)

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${OPENSSL_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIR}
)

if (DEVELOPER_BUILD)
    list(APPEND telegram_qt_SOURCES TLTypesDebug.cpp)
    list(APPEND telegram_qt_HEADERS TLTypesDebug.hpp)
    add_definitions(-DDEVELOPER_BUILD)
endif()

add_definitions(-DTELEGRAMQT_LIBRARY)

if (USE_QT4)
    QT4_WRAP_CPP(telegram_qt_MOC_SOURECES ${telegram_qt_META_HEADERS})
else()
    QT5_WRAP_CPP(telegram_qt_MOC_SOURECES ${telegram_qt_META_HEADERS})
endif()

if (STATIC_BUILD)
    add_library(telegram-qt${QT_VERSION_MAJOR} STATIC ${telegram_qt_SOURCES} ${telegram_qt_MOC_SOURECES})
else()
    add_library(telegram-qt${QT_VERSION_MAJOR} SHARED ${telegram_qt_SOURCES} ${telegram_qt_MOC_SOURECES})
endif()

target_include_directories(telegram-qt${QT_VERSION_MAJOR} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

if(USE_QT4)
    target_link_libraries(telegram-qt${QT_VERSION_MAJOR}
        ${QT_QTCORE_LIBRARY}
        ${QT_QTNETWORK_LIBRARY}
    )
    target_include_directories(telegram-qt${QT_VERSION_MAJOR} PRIVATE
        ${QT_INCLUDES}
    )
else()
    target_link_libraries(telegram-qt${QT_VERSION_MAJOR}
        Qt5::Core
        Qt5::Network
    )
    target_include_directories(telegram-qt${QT_VERSION_MAJOR} PRIVATE
        ${QT5_INCLUDES}
    )
endif()

target_link_libraries(telegram-qt${QT_VERSION_MAJOR}
    ${OPENSSL_LIBRARIES}
    ${ZLIB_LIBRARIES}
)

set(TELEGRAM_QT_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR}/telegram-qt${QT_VERSION_MAJOR})
set(TELEGRAM_QT_LIB_DIR ${CMAKE_INSTALL_LIBDIR})

# Set the correct version number
set_target_properties(
    telegram-qt${QT_VERSION_MAJOR} PROPERTIES
    SOVERSION ${TELEGRAM_QT_ABI}
    VERSION ${TELEGRAM_QT_VERSION}
)

install(
    TARGETS telegram-qt${QT_VERSION_MAJOR}
    LIBRARY DESTINATION ${TELEGRAM_QT_LIB_DIR}
    ARCHIVE DESTINATION ${TELEGRAM_QT_LIB_DIR}
    COMPONENT Library
)

install(
    DIRECTORY TelegramQt
    DESTINATION ${TELEGRAM_QT_INCLUDE_DIR}
    COMPONENT Devel
)

install(
    FILES ${telegram_qt_public_HEADERS}
    DESTINATION ${TELEGRAM_QT_INCLUDE_DIR}/TelegramQt
    COMPONENT Devel
)

# CMake find package stuff
include(CMakePackageConfigHelpers)

configure_file(TelegramQtConfig.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/TelegramQt${QT_VERSION_MAJOR}Config.cmake" @ONLY)
write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/TelegramQt${QT_VERSION_MAJOR}ConfigVersion.cmake"
                                    VERSION ${TELEGRAM_QT_VERSION}
                                    COMPATIBILITY ExactVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/TelegramQt${QT_VERSION_MAJOR}ConfigVersion.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/TelegramQt${QT_VERSION_MAJOR}Config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/TelegramQt${QT_VERSION_MAJOR}
    COMPONENT Devel
)

=== testApp/CMakeLists.txt ===
 
set(testApp_SOURCES
    main.cpp
    MainWindow.cpp
    CContactModel.cpp
    CMessageModel.cpp
    CChatInfoModel.cpp
)

set(testApp_HEADERS
    MainWindow.hpp
    CContactModel.hpp
    CMessageModel.hpp
    CChatInfoModel.hpp
)

set(testApp_FORMS
    MainWindow.ui
)

set(testApp_RESOURCES
    resources.qrc
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

if (USE_QT4)
    QT4_WRAP_UI(testApp_FORMS_HEADERS ${testApp_FORMS})
    QT4_ADD_RESOURCES(testApp_RESOURCES_RCC ${testApp_RESOURCES})
else()
    QT5_WRAP_UI(testApp_FORMS_HEADERS ${testApp_FORMS})
    QT5_ADD_RESOURCES(testApp_RESOURCES_RCC ${testApp_RESOURCES})
endif()

add_executable(testApp-qt${QT_VERSION_MAJOR} ${testApp_SOURCES} ${testApp_FORMS_HEADERS} ${testApp_RESOURCES_RCC})

set_target_properties(testApp-qt${QT_VERSION_MAJOR} PROPERTIES AUTOMOC TRUE)

if (USE_QT4)
    target_include_directories(testApp-qt${QT_VERSION_MAJOR} PRIVATE
        ${QT_INCLUDES}
    )
    target_link_libraries(testApp-qt${QT_VERSION_MAJOR} LINK_PRIVATE
        ${QT_QTCORE_LIBRARY}
        ${QT_QTGUI_LIBRARY}
        ${QT_QTNETWORK_LIBRARY}
    )
else()
    target_include_directories(testApp-qt${QT_VERSION_MAJOR} PRIVATE
        ${QT5_INCLUDES}
    )

    target_link_libraries(testApp-qt${QT_VERSION_MAJOR} LINK_PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Network
    )
endif()

target_link_libraries(testApp-qt${QT_VERSION_MAJOR} LINK_PUBLIC
    telegram-qt${QT_VERSION_MAJOR}
)

=== PKGBUILD ===
# Maintainer: Antonio Rojas <arojas@archlinux.org>

pkgname=telegram-qt
pkgver=0.1.0
pkgrel=4
pkgdesc="Qt bindings for the Telegram protocol"
arch=(x86_64)
url="https://github.com/Kaffeine/telegram-qt"
license=(GPL)
depends=(qt5-base)
makedepends=(cmake)
source=("https://github.com/Kaffeine/telegram-qt/archive/$pkgname-$pkgver.tar.gz")
md5sums=('fcc498a8c2655ee0d9877b1784e76cec')

prepare() {
  mkdir -p build
}

build() {
  cd build
  cmake ../$pkgname-$pkgname-$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_INSTALL_LIBDIR=lib \
    -DCMAKE_BUILD_TYPE=Release
  make
}

package() {
  cd build
  make DESTDIR="$pkgdir" install
}
